MODULE NOread_limit_sub_variables
! Module to create SAVE definitions for that variables that were used in the 
!   subroutines when 'limit.nc' or 'startphy.nc' were read

  IMPLICIT NONE

  REAL, ALLOCATABLE, DIMENSION(:), SAVE                  :: tsurf_limit
  REAL, ALLOCATABLE, DIMENSION(:), SAVE                  :: z0_limit
  REAL, ALLOCATABLE, DIMENSION(:), SAVE                  :: alb_limit

  CONTAINS

  SUBROUTINE NOread_limit_init(dlmdz, kglo)
! Subroutine to initialize the variables not readed from 'limit.nc'

    IMPLICIT NONE

    INTEGER, INTENT(IN)                                  :: dlmdz, kglo

    IF (ALLOCATED(tsurf_limit)) DEALLOCATE(tsurf_limit)
    ALLOCATE(tsurf_limit(dlmdz))

    IF (ALLOCATED(z0_limit)) DEALLOCATE(z0_limit)
    ALLOCATE(z0_limit(dlmdz))

    IF (ALLOCATED(alb_limit)) DEALLOCATE(alb_limit)
    ALLOCATE(alb_limit(dlmdz))

    RETURN

  END SUBROUTINE NOread_limit_init

END MODULE NOread_limit_sub_variables
